package com.qmth.distributed.print.business.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.distributed.print.business.entity.TCPaperStruct;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.Map;

/**
 * <p>
 * 试卷蓝图表 服务类
 * </p>
 *
 * @author wangliang
 * @since 2024-02-18
 */
public interface TCPaperStructService extends IService<TCPaperStruct> {

    /**
     * 根据考试id/课程编码/试卷编码查询数据库数据
     */
    public Boolean remove(Long examId, Long courseId, String paperNumber, Long teachCourseId);

    /**
     * 导入期末成绩-试卷结构excel
     */
    public Map<String, String> paperStructExcelImport(MultipartFile file, Long examId, Long courseId, String paperNumber, Long teachCourseId) throws IOException;

    /**
     * 同步试卷结构
     */
    public Map<String, String> paperStructSync(Long examId, Long courseId, String paperNumber, Long teachCourseId) throws IOException;

    /**
     * 根据考试id/科目编辑/试卷编码查询数据
     */
    public TCPaperStruct queryPaperStruct(Long examId, Long courseId, String paperNumber, Long teachCourseId);

    /**
     * 获取试卷结构同步锁
     */
    public void getPaperStructSyncLock(Long examId, Long courseId, String paperNumber, Long teachCourseId);

    /**
     * 获取试卷结构导入锁
     */
    public void getPaperStructImportLock(Long examId, Long courseId, String paperNumber, Long teachCourseId);
}
